
import
  std/typetraits, preserves

type
  TcpLocal* {.preservesRecord: "tcp-local".} = object
    `host`*: string
    `port`*: BiggestInt

  TcpPeerInfo*[Cap] {.preservesRecord: "tcp-peer".} = object
    `handle`*: Cap
    `local`*: TcpLocal
    `remote`*: TcpRemote

  TcpRemote* {.preservesRecord: "tcp-remote".} = object
    `host`*: string
    `port`*: BiggestInt

proc `$`*[Cap](x: TcpPeerInfo[Cap]): string =
  `$`(toPreserve(x, Cap))

proc encode*[Cap](x: TcpPeerInfo[Cap]): seq[byte] =
  encode(toPreserve(x, Cap))

proc `$`*(x: TcpLocal | TcpRemote): string =
  `$`(toPreserve(x))

proc encode*(x: TcpLocal | TcpRemote): seq[byte] =
  encode(toPreserve(x))
